#ifndef shortypluginH
#define shortypluginH
//---------------------------------------------------------------------------
typedef void (WINAPI *PLUGIN_FUNCTION)(HANDLE application, int user_data);
typedef void (WINAPI *TASK_FUNCTION)(DWORD pid);
typedef void (WINAPI *WINDOW_FUNCTION)(HWND window);
typedef void (WINAPI *OWN_FUNCTION)(HANDLE application, int own_grid_row);
typedef void*(WINAPI *PLUGIN_REALLOC)(void *ptr, unsigned int size);

typedef struct _PLUGIN_TASK_INFO
{
    DWORD pid;
    double cpu;
    double ram;
    double paged;
    double handles;
    double threads;
    char name[MAX_PATH];
} PLUGIN_TASK_INFO;

typedef struct _PLUGIN_WINDOW_INFO
{
    HANDLE hwindow;
    char caption[255];
    HICON icon;
} PLUGIN_WINDOW_INFO;

typedef struct _PLUGIN_FUNCTIONS
{
    PLUGIN_FUNCTION func;
    char menuname[255];
    HICON icon;
    int user_data;
} PLUGIN_FUNCTIONS;

typedef struct _TASK_FUNCTIONS
{
    TASK_FUNCTION func;
    char menuname[255];
} TASK_FUNCTIONS;

typedef struct _WINDOW_FUNCTIONS
{
    WINDOW_FUNCTION func;
    char menuname[255];
} WINDOW_FUNCTIONS;

typedef struct _OWN_GRID
{
    char caption[255];
    int col_width;
} OWN_GRID;

typedef struct _OWN_PAGE
{
    char page_caption[255];
    int column_count;
    int grid_row_height;
    int grid_first_row_height;
    int font_size;
    char font[255];
    int first_row_font_size;
    char first_row_font[255];
    bool show_v_line;
    bool show_h_line;
    OWN_GRID *grid;
} OWN_PAGE;

typedef struct _OWN_FUNCTIONS
{
    OWN_FUNCTION func;
    char menuname[255];
} OWN_FUNCTIONS;

typedef void (WINAPI *OWN_DATA_UPDATE)(void **data, int *row_count);


extern "C" __declspec(dllexport) bool WINAPI shorty_plugin_init(char **plugin_name, HICON *icon,
                                                                PLUGIN_FUNCTIONS **pf, int *pf_count,
                    		                                    TASK_FUNCTIONS **tf, int *tf_count,
                                                                WINDOW_FUNCTIONS **wf, int *wf_count,
                                                                PLUGIN_REALLOC p_realloc,
                                                                bool *hide_task_standart, bool *hide_window_standart);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_uninit(void);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_changeicon(HICON *hicon, PLUGIN_FUNCTION *dblclk);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_gettasks(PLUGIN_TASK_INFO **ti, int *ti_count);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_getwindows(PLUGIN_WINDOW_INFO **wi, int *wi_count);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_wincaptions(char **captions, char **page);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_taskcaptions(char **captions, char **page);
extern "C" __declspec(dllexport) void WINAPI shorty_plugin_addpage(OWN_PAGE *op, OWN_FUNCTIONS **of, int *of_count,
                                                                   OWN_DATA_UPDATE *update_function, unsigned int *interval);
//---------------------------------------------------------------------------
#endif
